﻿using System;
using System.Windows;

using Prism.Mvvm;
using Prism.Regions;

namespace TestLibrary.ViewModels
{
    /// <summary>
    /// 뷰 A 뷰 모델
    /// </summary>
    public class ViewAViewModel : BindableBase, IConfirmNavigationRequest
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Constructor
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region 생성자 - ViewAViewModel()

        /// <summary>
        /// 생성자
        /// </summary>
        public ViewAViewModel()
        {
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Constructor
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region 탐색 타겟 여부 구하기 - IsNavigationTarget(navigationContext)

        /// <summary>
        /// 탐색 타겟 여부 구하기
        /// </summary>
        /// <param name="navigationContext">탐색 컨텍스트</param>
        /// <returns>탐색 타겟 여부</returns>
        public bool IsNavigationTarget(NavigationContext navigationContext)
        {
            return true;
        }

        #endregion
        #region 탐색 진입시 처리하기 - OnNavigatedTo(navigationContext)

        /// <summary>
        /// 탐색 진입시 처리하기
        /// </summary>
        /// <param name="navigationContext">탐색 컨텍스트</param>
        public void OnNavigatedTo(NavigationContext navigationContext)
        {
        }

        #endregion
        #region 탐색 이탈시 처리하기 - OnNavigatedFrom(navigationContext)

        /// <summary>
        /// 탐색 이탈시 처리하기
        /// </summary>
        /// <param name="navigationContext">탐색 컨텍스트</param>
        public void OnNavigatedFrom(NavigationContext navigationContext)
        {
        }

        #endregion
        #region 탐색 요청 확인하기 - ConfirmNavigationRequest(navigationContext, continuationCallback)

        /// <summary>
        /// 탐색 요청 확인하기
        /// </summary>
        /// <param name="navigationContext">탐색 컨텍스트</param>
        /// <param name="continuationCallback">후속 콜백</param>
        public void ConfirmNavigationRequest(NavigationContext navigationContext, Action<bool> continuationCallback)
        {
            bool result = true;

            if(MessageBox.Show("Do you to navigate?", "Navigate?", MessageBoxButton.YesNo) == MessageBoxResult.No)
            {
                result = false;
            }

            continuationCallback(result);
        }

        #endregion
    }
}